import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { StartImportRequestFilterSensitiveLog } from "../models/models_1";
import { de_StartImportCommand, se_StartImportCommand } from "../protocols/Aws_restJson1";
export { $Command };
export class StartImportCommand extends $Command
    .classBuilder()
    .ep(commonParams)
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("LexModelBuildingServiceV2", "StartImport", {})
    .n("LexModelsV2Client", "StartImportCommand")
    .f(StartImportRequestFilterSensitiveLog, void 0)
    .ser(se_StartImportCommand)
    .de(de_StartImportCommand)
    .build() {
}
